Index: /trunk/doc/manual/en_US/user_Troubleshooting.xml
===================================================================
--- /trunk/doc/manual/en_US/user_Troubleshooting.xml	(revision 35191)
+++ /trunk/doc/manual/en_US/user_Troubleshooting.xml	(revision 35192)
@@ -929,29 +929,33 @@
 
     <sect2>
-      <title>Bridged Networking</title>
-
-      <para>In case no Bridge adapters are listed in bridged networking
-      settings UI, this typically means that Bridged networking driver was not
-      installed properly on your host. This could be due to any of the
-      following reasons: <itemizedlist>
-          <listitem>
-            <para>The maximum allowed filter count is reached on the host. The
-            MSI log would mention the 0x8004a029 error code returned on NetFlt
-            network component install: "VBoxNetCfgWinInstallComponent: Install
-            failed, hr (0x8004a029)". The solution would typically be to
-            increase the maximum filter count under
-            HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Control\Network\MaxNumFilters
-            (the maximum number allowed is 14), reboot and try to re-install
-            the VirtualBox</para>
-          </listitem>
-
-          <listitem>
-            <para>Inf cache is corrupt. The %windir%\inf\setupapi.log (for XP)
-            or %windir%\inf\setupapi.dev.log (for Vista+) would typically
-            mention the failure to find a suitable driver package for either
-            sun_VBoxNetFlt or sun_VBoxNetFltmp components. The solution is to
-            uninstall VirtualBox, remove the inf cache
-            (%windir%\inf\INFCACHE.1, reboot and try to re-install the
-            VirtualBox</para>
+      <title>Bridged networking adapters missing</title>
+
+      <para>If no bridged adapters show up in the "Networking" section of the
+      VM settings, this typically means that the bridged networking driver was
+      not installed properly on your host. This could be due to the following
+      reasons: <itemizedlist>
+          <listitem>
+            <para>The maximum allowed filter count was reached on the host. In
+            this case, the MSI log would mention the
+            <computeroutput>0x8004a029</computeroutput> error code returned on
+            NetFlt network component install:<screen>VBoxNetCfgWinInstallComponent: Install failed, hr (0x8004a029)</screen></para>
+
+            <para>You can try to increase the maximum filter count in the
+            Windows registry at the following key:<screen>HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Control\Network\MaxNumFilters</screen>The
+            maximum number allowed is 14. After a reboot, try to re-install
+            VirtualBox.</para>
+          </listitem>
+
+          <listitem>
+            <para>The INF cache is corrupt. In this case, the install log
+            (<computeroutput>%windir%\inf\setupapi.log</computeroutput> on XP
+            or <computeroutput>%windir%\inf\setupapi.dev.log</computeroutput>
+            on Vista or later) would typically mention the failure to find a
+            suitable driver package for either the
+            <computeroutput>sun_VBoxNetFlt</computeroutput> or
+            <computeroutput>sun_VBoxNetFltmp</computeroutput> components. The
+            solution then is to uninstall VirtualBox, remove the INF cache
+            (<computeroutput>%windir%\inf\INFCACHE.1</computeroutput>), reboot
+            and try to re-install VirtualBox</para>
           </listitem>
         </itemizedlist></para>
@@ -959,17 +963,17 @@
 
     <sect2>
-      <title>Host-Only Networking</title>
-
-      <para>Host-Only adapter creation (either via GUI or VBoxManage) may fail
-      due to any of the following reasons: <itemizedlist>
-          <listitem>
-            <para>Inf cache is corrupt. The %windir%\inf\setupapi.log (for XP)
-            or %windir%\inf\setupapi.dev.log (for Vista+) would typically
-            mention the failure to find a suitable driver package for
-            sun_VBoxNetAdp component. The solution is to uninstall VirtualBox,
-            remove the inf cache (%windir%\inf\INFCACHE.1, reboot and try to
-            re-install the VirtualBox</para>
-          </listitem>
-        </itemizedlist></para>
+      <title>Host-only networking adapters cannot be created</title>
+
+      <para>If host-only adapter cannot be created (either via the Manager or
+      VBoxManage), then the INF cache is probably corrupt. In this case, the
+      install log (<computeroutput>%windir%\inf\setupapi.log</computeroutput>
+      on XP or <computeroutput>%windir%\inf\setupapi.dev.log</computeroutput>
+      on Vista or later) would typically mention the failure to find a
+      suitable driver package for the
+      <computeroutput>sun_VBoxNetAdp</computeroutput> component. Again, as
+      with the bridged networking problem described above, the solution is to
+      uninstall VirtualBox, remove the INF cache
+      (<computeroutput>%windir%\inf\INFCACHE.1</computeroutput>), reboot and
+      try to re-install VirtualBox.</para>
     </sect2>
   </sect1>