Index: /trunk/doc/manual/en_US/SDKRef.xml
===================================================================
--- /trunk/doc/manual/en_US/SDKRef.xml	(revision 35295)
+++ /trunk/doc/manual/en_US/SDKRef.xml	(revision 35296)
@@ -3566,9 +3566,8 @@
 
               <listitem>
-                <para><computeroutput>ISystemProperties::getMaxVDISize()</computeroutput>
-                has been replaced by the <xref
-                linkend="ISystemProperties__infoVDSize"
-                xreflabel="ISystemProperties::infoVDSize" /> attribute; this
-                now uses bytes instead of megabytes.</para>
+                <para>The <xref linkend="ISystemProperties__infoVDSize"
+                xreflabel="ISystemProperties::infoVDSize" /> attribute
+                replaces the <computeroutput>getMaxVDISize()</computeroutput>
+                API call; this now uses bytes instead of megabytes.</para>
               </listitem>
             </itemizedlist></para>
@@ -3593,5 +3592,5 @@
               <listitem>
                 <para>To reduce code duplication and for consistency with the
-                aforementioned media API changes,
+                aforementioned media APIs,
                 <computeroutput>IVirtualBox::getMachine()</computeroutput> has
                 been merged with <xref linkend="IVirtualBox__findMachine"
@@ -3704,48 +3703,45 @@
           interface: <itemizedlist>
               <listitem>
-                <para><computeroutput>IVRDPServer</computeroutput> interface
-                has been renamed to <xref linkend="IVRDEServer"
+                <para><computeroutput>IVRDPServer</computeroutput> has been
+                renamed to <xref linkend="IVRDEServer"
                 xreflabel="IVRDEServer" />.</para>
               </listitem>
 
               <listitem>
-                <para><computeroutput>IRemoteDisplayInfo</computeroutput>
-                interface has been renamed to <xref linkend="IVRDEServerInfo"
+                <para><computeroutput>IRemoteDisplayInfo</computeroutput> has
+                been renamed to <xref linkend="IVRDEServerInfo"
                 xreflabel="IVRDEServerInfo" />.</para>
               </listitem>
 
               <listitem>
-                <para><computeroutput>IMachine::VRDPServer</computeroutput>
-                attribute has been renamed to <xref
-                linkend="IMachine__VRDEServer"
-                xreflabel="IMachine::VRDEServer" />.</para>
-              </listitem>
-
-              <listitem>
-                <para><computeroutput>IConsole::RemoteDisplayInfo</computeroutput>
-                attribute has been renamed to <xref
-                linkend="IConsole__VRDEServerInfo"
-                xreflabel="IConsole::VRDEServerInfo" />.</para>
-              </listitem>
-
-              <listitem>
-                <para><computeroutput>ISystemProperties::RemoteDisplayAuthLibrary</computeroutput>
-                attribute has been renamed to <xref
-                linkend="ISystemProperties__VRDEAuthLibrary"
-                xreflabel="ISystemProperties::VRDEAuthLibrary" />.</para>
-              </listitem>
-
-              <listitem>
-                <para>Following methods has been implemented in
+                <para><xref linkend="IMachine__VRDEServer"
+                xreflabel="IMachine::VRDEServer" /> replaces
+                <computeroutput>VRDPServer.</computeroutput></para>
+              </listitem>
+
+              <listitem>
+                <para><xref linkend="IConsole__VRDEServerInfo"
+                xreflabel="IConsole::VRDEServerInfo" /> replaces
+                <computeroutput>RemoteDisplayInfo</computeroutput>.</para>
+              </listitem>
+
+              <listitem>
+                <para><xref linkend="ISystemProperties__VRDEAuthLibrary"
+                xreflabel="ISystemProperties::VRDEAuthLibrary" /> replaces
+                <computeroutput>RemoteDisplayAuthLibrary</computeroutput>.</para>
+              </listitem>
+
+              <listitem>
+                <para>The following methods have been implemented in
                 <computeroutput>IVRDEServer</computeroutput> to support
                 generic VRDE properties: <itemizedlist>
                     <listitem>
                       <para><xref linkend="IVRDEServer__setVRDEProperty"
-                      xreflabel="IVRDEServer::SetVRDEProperty" /></para>
+                      xreflabel="IVRDEServer::setVRDEProperty" /></para>
                     </listitem>
 
                     <listitem>
                       <para><xref linkend="IVRDEServer__getVRDEProperty"
-                      xreflabel="IVRDEServer::GetVRDEProperty" /></para>
+                      xreflabel="IVRDEServer::getVRDEProperty" /></para>
                     </listitem>
 
@@ -3756,10 +3752,10 @@
                   </itemizedlist></para>
 
-                <para>A few implementation specific attributes of the old
+                <para>A few implementation-specific attributes of the old
                 <computeroutput>IVRDPServer</computeroutput> interface have
                 been removed and replaced with properties: <itemizedlist>
                     <listitem>
                       <para><computeroutput>IVRDPServer::Ports</computeroutput>
-                      -- replaced with
+                      has been replaced with the
                       <computeroutput>"TCP/Ports"</computeroutput> property.
                       The property value is a string, which contains a
@@ -3772,5 +3768,5 @@
                     <listitem>
                       <para><computeroutput>IVRDPServer::NetAddress</computeroutput>
-                      -- replaced with
+                      has been replaced with the
                       <computeroutput>"TCP/Address"</computeroutput> property.
                       The property value is an IP address string. Example:
@@ -3780,5 +3776,5 @@
                     <listitem>
                       <para><computeroutput>IVRDPServer::VideoChannel</computeroutput>
-                      -- replaced with
+                      has been replaced with the
                       <computeroutput>"VideoChannel/Enabled"</computeroutput>
                       property. The property value is either
@@ -3789,5 +3785,5 @@
                     <listitem>
                       <para><computeroutput>IVRDPServer::VideoChannelQuality</computeroutput>
-                      -- replaced with
+                      has been replaced with the
                       <computeroutput>"VideoChannel/Quality"</computeroutput>
                       property. The property value is a string which contain a