Index: trunk/src/VBox/VMM/testcase/Makefile.kmk
===================================================================
--- trunk/src/VBox/VMM/testcase/Makefile.kmk	(revision 35308)
+++ trunk/src/VBox/VMM/testcase/Makefile.kmk	(revision 35333)
@@ -120,5 +120,7 @@
  endif
  tstVMStructRC_SOURCES   = tstVMStructRC.cpp
- tstVMStructRC_INCS      = $(VBOX_PATH_VMM_SRC) $(VBOX_PATH_VMM_SRC)/PATM
+ tstVMStructRC_INCS      = \
+	$(VBOX_PATH_VMM_SRC)/include \
+	$(VBOX_PATH_VMM_SRC)/PATM
 endif
 
@@ -133,5 +135,8 @@
  tstVMStructSize_DEFS  += VBOX_WITH_RAW_MODE
 endif
-tstVMStructSize_INCS    = $(VBOX_PATH_VMM_SRC) $(VBOX_PATH_VMM_SRC)/PATM $(VBOX_VMM_TESTCASE_OUT_DIR)
+tstVMStructSize_INCS    = \
+	$(VBOX_PATH_VMM_SRC)/include \
+	$(VBOX_PATH_VMM_SRC)/PATM \
+	$(VBOX_VMM_TESTCASE_OUT_DIR)
 tstVMStructSize_SOURCES = tstVMStructSize.cpp
 ifdef VBOX_WITH_RAW_MODE
@@ -156,5 +161,7 @@
  tstAsmStructs_DEFS    += VBOX_WITH_VMMR0_DISABLE_LAPIC_NMI
 endif
-tstAsmStructs_INCS      = $(VBOX_PATH_VMM_SRC) $(VBOX_VMM_TESTCASE_OUT_DIR)
+tstAsmStructs_INCS      = \
+	$(VBOX_PATH_VMM_SRC)/include \
+	$(VBOX_VMM_TESTCASE_OUT_DIR)
 tstAsmStructs_SOURCES   = tstAsmStructs.cpp
 tstAsmStructs.cpp_DEPS  = $(VBOX_VMM_TESTCASE_OUT_DIR)/tstAsmStructsHC.h
@@ -169,5 +176,7 @@
   tstAsmStructsRC_DEFS  += VBOX_WITH_VMMR0_DISABLE_LAPIC_NMI
  endif
- tstAsmStructsRC_INCS    = $(VBOX_PATH_VMM_SRC) $(VBOX_VMM_TESTCASE_OUT_DIR)
+ tstAsmStructsRC_INCS    = \
+	$(VBOX_PATH_VMM_SRC)/include \
+	$(VBOX_VMM_TESTCASE_OUT_DIR)
  tstAsmStructsRC_SOURCES = tstAsmStructs.cpp
  tstAsmStructs.cpp_DEPS += $(VBOX_VMM_TESTCASE_OUT_DIR)/tstAsmStructsRC.h
@@ -184,4 +193,5 @@
 
 tstSSM_TEMPLATE         = VBOXR3TSTEXE
+tstSSM_INCS             = $(VBOX_PATH_VMM_SRC)/include
 tstSSM_SOURCES          = tstSSM.cpp
 tstSSM_LIBS             = $(LIB_VMM) $(LIB_REM) $(LIB_RUNTIME)
@@ -200,5 +210,5 @@
 tstVMMR0CallHost-1_TEMPLATE = VBOXR3TSTEXE
 tstVMMR0CallHost-1_DEFS = VMM_R0_NO_SWITCH_STACK
-tstVMMR0CallHost-1_INCS = $(VBOX_PATH_VMM_SRC)
+tstVMMR0CallHost-1_INCS = $(VBOX_PATH_VMM_SRC)/include
 tstVMMR0CallHost-1_SOURCES = \
 	tstVMMR0CallHost-1.cpp
@@ -263,8 +273,10 @@
 ifdef VBOX_WITH_PDM_ASYNC_COMPLETION
  tstPDMAsyncCompletion_TEMPLATE         = VBOXR3EXE
+ tstPDMAsyncCompletion_INCS             = $(VBOX_PATH_VMM_SRC)/include
  tstPDMAsyncCompletion_SOURCES          = tstPDMAsyncCompletion.cpp
  tstPDMAsyncCompletion_LIBS             = $(LIB_VMM) $(LIB_REM) $(LIB_RUNTIME)
 
  tstPDMAsyncCompletionStress_TEMPLATE   = VBOXR3EXE
+ tstPDMAsyncCompletionStress_INCS       = $(VBOX_PATH_VMM_SRC)/include
  tstPDMAsyncCompletionStress_SOURCES    = tstPDMAsyncCompletionStress.cpp
  tstPDMAsyncCompletionStress_LIBS       = $(LIB_VMM) $(LIB_REM) $(LIB_RUNTIME)
@@ -310,5 +322,6 @@
 		) \
 		-f $(if $(eq $(KBUILD_TARGET),darwin),macho,elf) \
-		$(foreach inc,$(INCS) $(VBOX_PATH_VMM_SRC)/testcase $(VBOX_VMM_TESTCASE_OUT_DIR),-I$(inc)/)
+		$(foreach inc,$(INCS) $(VBOX_PATH_VMM_SRC)/testcase $(VBOX_PATH_VMM_SRC)/include $(VBOX_VMM_TESTCASE_OUT_DIR)\
+			,-I$(inc)/)
 
 # 1a. make a header file which makes all the structures+members globals.
@@ -320,8 +333,8 @@
 		$(DEPTH)/include/VBox/sup.mac \
 		$(DEPTH)/include/VBox/vm.mac \
-		$(VBOX_PATH_VMM_SRC)/CPUMInternal.mac \
-		$(VBOX_PATH_VMM_SRC)/TRPMInternal.mac \
-		$(VBOX_PATH_VMM_SRC)/HWACCMInternal.mac \
-		$(VBOX_PATH_VMM_SRC)/VMMInternal.mac \
+		$(VBOX_PATH_VMM_SRC)/include/CPUMInternal.mac \
+		$(VBOX_PATH_VMM_SRC)/include/TRPMInternal.mac \
+		$(VBOX_PATH_VMM_SRC)/include/HWACCMInternal.mac \
+		$(VBOX_PATH_VMM_SRC)/include/VMMInternal.mac \
 		$(VBOX_PATH_VMM_SRC)/testcase/Makefile.kmk \
 		$(PATH_ROOT)/Config.kmk $(LOCALCFG) $(AUTOCFG) \
Index: trunk/src/VBox/VMM/testcase/tstAsmStructs.cpp
===================================================================
--- trunk/src/VBox/VMM/testcase/tstAsmStructs.cpp	(revision 35308)
+++ trunk/src/VBox/VMM/testcase/tstAsmStructs.cpp	(revision 35333)
@@ -24,5 +24,5 @@
 #include "TRPMInternal.h"
 #include "HWACCMInternal.h"
-#include "../VMMSwitcher/VMMSwitcher.h"
+#include "VMMSwitcher.h"
 #include "VMMInternal.h"
 #include <VBox/vm.h>
Index: trunk/src/VBox/VMM/testcase/tstAsmStructsAsm.asm
===================================================================
--- trunk/src/VBox/VMM/testcase/tstAsmStructsAsm.asm	(revision 35308)
+++ trunk/src/VBox/VMM/testcase/tstAsmStructsAsm.asm	(revision 35333)
@@ -23,12 +23,12 @@
 %endif
 
-%include "../CPUMInternal.mac"
-%include "../HWACCMInternal.mac"
-%include "../TRPMInternal.mac"
-%include "../VMMInternal.mac"
+%include "CPUMInternal.mac"
+%include "HWACCMInternal.mac"
+%include "TRPMInternal.mac"
+%include "VMMInternal.mac"
 %include "VBox/cpum.mac"
 %include "VBox/vm.mac"
 %include "VBox/sup.mac"
-%include "../VMMSwitcher/VMMSwitcher.mac"
+%include "VMMSwitcher.mac"
 %ifdef DO_GLOBALS
  %include "tstAsmStructsAsm.mac"
Index: trunk/src/VBox/VMM/testcase/tstPDMAsyncCompletion.cpp
===================================================================
--- trunk/src/VBox/VMM/testcase/tstPDMAsyncCompletion.cpp	(revision 35308)
+++ trunk/src/VBox/VMM/testcase/tstPDMAsyncCompletion.cpp	(revision 35333)
@@ -26,5 +26,5 @@
 #define LOG_GROUP LOG_GROUP_PDM_ASYNC_COMPLETION
 
-#include "../VMInternal.h" /* UVM */
+#include "VMInternal.h" /* UVM */
 #include <VBox/vm.h>
 #include <VBox/uvm.h>
Index: trunk/src/VBox/VMM/testcase/tstPDMAsyncCompletionStress.cpp
===================================================================
--- trunk/src/VBox/VMM/testcase/tstPDMAsyncCompletionStress.cpp	(revision 35308)
+++ trunk/src/VBox/VMM/testcase/tstPDMAsyncCompletionStress.cpp	(revision 35333)
@@ -23,5 +23,5 @@
 #define LOG_GROUP LOG_GROUP_PDM_ASYNC_COMPLETION
 
-#include "../VMInternal.h" /* UVM */
+#include "VMInternal.h" /* UVM */
 #include <VBox/vm.h>
 #include <VBox/uvm.h>
Index: trunk/src/VBox/VMM/testcase/tstSSM.cpp
===================================================================
--- trunk/src/VBox/VMM/testcase/tstSSM.cpp	(revision 35308)
+++ trunk/src/VBox/VMM/testcase/tstSSM.cpp	(revision 35333)
@@ -21,5 +21,5 @@
 *******************************************************************************/
 #include <VBox/ssm.h>
-#include "../VMInternal.h" /* createFakeVM */
+#include "VMInternal.h" /* createFakeVM */
 #include <VBox/vm.h>
 #include <VBox/uvm.h>
Index: trunk/src/VBox/VMM/testcase/tstVMStructRC.cpp
===================================================================
--- trunk/src/VBox/VMM/testcase/tstVMStructRC.cpp	(revision 35308)
+++ trunk/src/VBox/VMM/testcase/tstVMStructRC.cpp	(revision 35333)
@@ -59,23 +59,23 @@
 #include <VBox/vmm.h>
 #include <VBox/stam.h>
-#include "../PDMInternal.h"
+#include "PDMInternal.h"
 #include <VBox/pdm.h>
-#include "../CFGMInternal.h"
-#include "../CPUMInternal.h"
-#include "../MMInternal.h"
-#include "../PGMInternal.h"
-#include "../SELMInternal.h"
-#include "../TRPMInternal.h"
-#include "../TMInternal.h"
-#include "../IOMInternal.h"
-#include "../REMInternal.h"
-#include "../HWACCMInternal.h"
-#include "../PATM/PATMInternal.h"
-#include "../VMMInternal.h"
-#include "../DBGFInternal.h"
-#include "../STAMInternal.h"
-#include "../PATM/CSAMInternal.h"
-#include "../EMInternal.h"
-#include "../REMInternal.h"
+#include "CFGMInternal.h"
+#include "CPUMInternal.h"
+#include "MMInternal.h"
+#include "PGMInternal.h"
+#include "SELMInternal.h"
+#include "TRPMInternal.h"
+#include "TMInternal.h"
+#include "IOMInternal.h"
+#include "REMInternal.h"
+#include "HWACCMInternal.h"
+#include "PATMInternal.h"
+#include "VMMInternal.h"
+#include "DBGFInternal.h"
+#include "STAMInternal.h"
+#include "CSAMInternal.h"
+#include "EMInternal.h"
+#include "REMInternal.h"
 #include <VBox/vm.h>
 #include <VBox/param.h>
Index: trunk/src/VBox/VMM/testcase/tstVMStructSize.cpp
===================================================================
--- trunk/src/VBox/VMM/testcase/tstVMStructSize.cpp	(revision 35308)
+++ trunk/src/VBox/VMM/testcase/tstVMStructSize.cpp	(revision 35333)
@@ -50,6 +50,6 @@
 #include "EMInternal.h"
 #include "REMInternal.h"
-#include "VMMR0/GMMR0Internal.h"
-#include "VMMR0/GVMMR0Internal.h"
+#include "../VMMR0/GMMR0Internal.h"
+#include "../VMMR0/GVMMR0Internal.h"
 #include <VBox/vm.h>
 #include <VBox/uvm.h>