Index: trunk/src/VBox/Devices/Graphics/BIOS/Makefile.kmk
===================================================================
--- trunk/src/VBox/Devices/Graphics/BIOS/Makefile.kmk	(revision 34399)
+++ trunk/src/VBox/Devices/Graphics/BIOS/Makefile.kmk	(revision 35380)
@@ -38,28 +38,28 @@
 VgaBiosBin_DEFS     = IN_VBOXDD2
 VgaBiosBin_INCS     = $(VBOX_PATH_DEVICES_SRC)
-VgaBiosBin_SOURCES  = $(PATH_VgaBiosBin)/VgaBiosBin.c
+VgaBiosBin_SOURCES  = $(VgaBiosBin_0_OUTDIR)/VgaBiosBin.c
 VgaBiosBin_CLEAN    = \
-	$(PATH_VgaBiosBin)/vbetables.h \
+	$(VgaBiosBin_0_OUTDIR)/vbetables.h \
 	\
-	$(PATH_VgaBiosBin)/_vgabios_.c \
-	$(PATH_VgaBiosBin)/vgabios0.s \
-	$(PATH_VgaBiosBin)/vgabios1.s \
-	$(PATH_VgaBiosBin)/vgabios.tmp \
-	$(PATH_VgaBiosBin)/vgabios.lst \
-	$(PATH_VgaBiosBin)/vgabios.bin \
-	$(PATH_VgaBiosBin)/VgaBiosBin.c \
-	$(PATH_VgaBiosBin)/VgaDefBiosLogo.c \
+	$(VgaBiosBin_0_OUTDIR)/_vgabios_.c \
+	$(VgaBiosBin_0_OUTDIR)/vgabios0.s \
+	$(VgaBiosBin_0_OUTDIR)/vgabios1.s \
+	$(VgaBiosBin_0_OUTDIR)/vgabios.tmp \
+	$(VgaBiosBin_0_OUTDIR)/vgabios.lst \
+	$(VgaBiosBin_0_OUTDIR)/vgabios.bin \
+	$(VgaBiosBin_0_OUTDIR)/VgaBiosBin.c \
+	$(VgaBiosBin_0_OUTDIR)/VgaDefBiosLogo.c \
 	\
-	$(PATH_VgaBiosBin)/_vgabios-cirrus_.c \
-	$(PATH_VgaBiosBin)/vgabios-cirrus0.s \
-	$(PATH_VgaBiosBin)/vgabios-cirrus1.s \
-	$(PATH_VgaBiosBin)/vgabios-cirrus.tmp \
-	$(PATH_VgaBiosBin)/vgabios-cirrus.lst \
-	$(PATH_VgaBiosBin)/vgabios-cirrus.bin
+	$(VgaBiosBin_0_OUTDIR)/_vgabios-cirrus_.c \
+	$(VgaBiosBin_0_OUTDIR)/vgabios-cirrus0.s \
+	$(VgaBiosBin_0_OUTDIR)/vgabios-cirrus1.s \
+	$(VgaBiosBin_0_OUTDIR)/vgabios-cirrus.tmp \
+	$(VgaBiosBin_0_OUTDIR)/vgabios-cirrus.lst \
+	$(VgaBiosBin_0_OUTDIR)/vgabios-cirrus.bin
 
 #
 # Rule for making the bios.
 #
-$$(PATH_VgaBiosBin)/VgaBiosBin.c: $$(PATH_VgaBiosBin)/vgabios.bin $(VBOX_BIN2C)
+$$(VgaBiosBin_0_OUTDIR)/VgaBiosBin.c: $$(VgaBiosBin_0_OUTDIR)/vgabios.bin $(VBOX_BIN2C)
 	$(call MSG_TOOL,bin2c,VgaBiosBin,$<,$@)
 	$(QUIET)$(VBOX_BIN2C) -min 36 -max 36 -mask 0x0fff -ascii -export VgaBiosBinary $< $@
@@ -70,10 +70,10 @@
 
 # 1. create vbetables.h
-$$(PATH_VgaBiosBin)/vbetables.h: $(MAKEFILE_CURRENT) $$(TARGET_vbetables-gen) | $$(dir $$@)
+$$(VgaBiosBin_0_OUTDIR)/vbetables.h: $(MAKEFILE_CURRENT) $$(TARGET_vbetables-gen) | $$(dir $$@)
 	$(QUIET)$(REDIRECT) -wo $@ -- $(TARGET_vbetables-gen)
 
 # 2. precompile
 # WARNING! DEBUG is undefined here to keep the image size stable between debug and release builds.
-$$(PATH_VgaBiosBin)/_vgabios_.c: $(addprefix $(PATH_SUB_CURRENT)/,vgabios.c vgabios.h vbe.h vgatables.h vgafonts.h vbe.c clext.c) $$(PATH_VgaBiosBin)/vbetables.h $(PATH_ROOT)/include/VBox/Hardware/VBoxVideoVBE.h $(VBOX_VERSION_STAMP)
+$$(VgaBiosBin_0_OUTDIR)/_vgabios_.c: $(addprefix $(PATH_SUB_CURRENT)/,vgabios.c vgabios.h vbe.h vgatables.h vgafonts.h vbe.c clext.c) $$(VgaBiosBin_0_OUTDIR)/vbetables.h $(PATH_ROOT)/include/VBox/Hardware/VBoxVideoVBE.h $(VBOX_VERSION_STAMP)
 	$(call MSG_TOOL,cpp,VgaBiosBin,$<,$@)
 	$(QUIET)$(TOOL_$(VBOX_GCC_TOOL)_CC) -E -P \
@@ -86,21 +86,21 @@
 # 3. compile
 # BCC tempfile clashes, order the BCC jobs to make sure they don't interfere with one another.
-$$(PATH_VgaBiosBin)/vgabios0.s: $$(PATH_VgaBiosBin)/_vgabios_.c | $(VBOX_BCC_JOBS)
+$$(VgaBiosBin_0_OUTDIR)/vgabios0.s: $$(VgaBiosBin_0_OUTDIR)/_vgabios_.c | $(VBOX_BCC_JOBS)
 	$(call MSG_COMPILE,VgaBiosBin,$<,$@,C)
 	$(QUIET)$(VBOX_BCC) -o $@ -C-c -D__i86__ -0 -S $^
-VBOX_BCC_JOBS += $(PATH_VgaBiosBin)/vgabios0.s
+VBOX_BCC_JOBS += $(VgaBiosBin_0_OUTDIR)/vgabios0.s
 
 # 4. preprocess intermediate assembly.
-$$(PATH_VgaBiosBin)/vgabios1.s: $$(PATH_VgaBiosBin)/vgabios0.s
+$$(VgaBiosBin_0_OUTDIR)/vgabios1.s: $$(VgaBiosBin_0_OUTDIR)/vgabios0.s
 	$(call MSG_TOOL,Adjusting BCC Assembly,VgaBiosBin,$<,$@)
 	$(QUIET)$(SED) -e 's/^\.text//' -e 's/^\.data//' --output $@ $^
 
 # 5. assemble
-$$(PATH_VgaBiosBin)/vgabios.tmp $$(PATH_VgaBiosBin)/vgabios.lst: $$(PATH_VgaBiosBin)/vgabios1.s
+$$(VgaBiosBin_0_OUTDIR)/vgabios.tmp $$(VgaBiosBin_0_OUTDIR)/vgabios.lst: $$(VgaBiosBin_0_OUTDIR)/vgabios1.s
 	$(call MSG_COMPILE,VgaBiosBin,$<,$@,AS)
-	$(QUIET)$(REDIRECT) -ri $^ -- $(VBOX_AS86) -b $(PATH_VgaBiosBin)/vgabios.tmp -u- -w- -g -0 -j -O -l $(PATH_VgaBiosBin)/vgabios.lst
+	$(QUIET)$(REDIRECT) -ri $^ -- $(VBOX_AS86) -b $(VgaBiosBin_0_OUTDIR)/vgabios.tmp -u- -w- -g -0 -j -O -l $(VgaBiosBin_0_OUTDIR)/vgabios.lst
 
 # 6. checksums
-$$(PATH_VgaBiosBin)/vgabios.bin: $$(PATH_VgaBiosBin)/vgabios.tmp $$(VBOX_BIOSSUMS)
+$$(VgaBiosBin_0_OUTDIR)/vgabios.bin: $$(VgaBiosBin_0_OUTDIR)/vgabios.tmp $$(VBOX_BIOSSUMS)
 	$(call MSG_TOOL,biossums,VgaBiosBin,$<,$@)
 	$(QUIET)$(VBOX_BIOSSUMS) $< $@
@@ -112,10 +112,10 @@
 VgaDefBiosLogo_TEMPLATE  = VBOXR3
 VgaDefBiosLogo_INCS      = $(VBOX_PATH_DEVICES_SRC)
-VgaDefBiosLogo_SOURCES   = $(PATH_VgaBiosBin)/VgaDefBiosLogo.c
+VgaDefBiosLogo_SOURCES   = $(VgaBiosBin_0_OUTDIR)/VgaDefBiosLogo.c
 
 #
 # Rule for making the bios logo.
 #
-$$(PATH_VgaBiosBin)/VgaDefBiosLogo.c: $(VBOX_BRAND_BIOS_LOGO) $(VBOX_BIN2C)
+$$(VgaBiosBin_0_OUTDIR)/VgaDefBiosLogo.c: $(VBOX_BRAND_BIOS_LOGO) $(VBOX_BIN2C)
 	$(call MSG_TOOL,bin2c,VgaBiosBin,$<,$@)
 	$(QUIET)$(VBOX_BIN2C) VgaDefBiosLogo $< $@