Index: trunk/src/VBox/Additions/Makefile.kmk
===================================================================
--- trunk/src/VBox/Additions/Makefile.kmk	(revision 35380)
+++ trunk/src/VBox/Additions/Makefile.kmk	(revision 35381)
@@ -95,18 +95,18 @@
 	$(PATH_TARGET)/VBoxGuestCat.dir
 
-  $(PATH_TARGET)/VBoxGuestCat.dir/VBoxGuest.inf: $(PATH_SUB_CURRENT)/common/VBoxGuest/win/VBoxGuest.inf $(MAKEFILE_CURRENT) | $$(call DIRDEP,$$(@D))
+  $(PATH_TARGET)/VBoxGuestCat.dir/VBoxGuest.inf: $(PATH_SUB_CURRENT)/common/VBoxGuest/win/VBoxGuest.inf $(MAKEFILE_CURRENT) | $$(dir $$@)
 	$(call MSG_GENERATE,VBoxGuest-inf,$@,$<)
 	$(call VBOX_EDIT_INF_FN,$<,$@)
 
-  $(PATH_TARGET)/VBoxGuestCat.dir/VBoxGuest.sys:   $$(TARGET_VBoxGuest) | $$(call DIRDEP,$$(@D))
+  $(PATH_TARGET)/VBoxGuestCat.dir/VBoxGuest.sys:   $$(TARGET_VBoxGuest) | $$(dir $$@)
 	$(INSTALL) -m 644 $< $(@D)
 
-  $(PATH_TARGET)/VBoxGuestCat.dir/VBoxControl.exe: $$(TARGET_VBoxControl) | $$(call DIRDEP,$$(@D))
+  $(PATH_TARGET)/VBoxGuestCat.dir/VBoxControl.exe: $$(TARGET_VBoxControl) | $$(dir $$@)
 	$(INSTALL) -m 755 $< $(@D)
 
-  $(PATH_TARGET)/VBoxGuestCat.dir/VBoxTray.exe:    $$(TARGET_VBoxTray) | $$(call DIRDEP,$$(@D))
+  $(PATH_TARGET)/VBoxGuestCat.dir/VBoxTray.exe:    $$(TARGET_VBoxTray) | $$(dir $$@)
 	$(INSTALL) -m 755 $< $(@D)
 
-  $(PATH_TARGET)/VBoxGuestCat.dir/VBCoInst.dll:    $$(TARGET_VBCoInst) | $$(call DIRDEP,$$(@D))
+  $(PATH_TARGET)/VBoxGuestCat.dir/VBCoInst.dll:    $$(TARGET_VBCoInst) | $$(dir $$@)
 	$(INSTALL) -m 644 $< $(@D)
 
Index: trunk/src/VBox/Additions/WINNT/Graphics/Makefile.kmk
===================================================================
--- trunk/src/VBox/Additions/WINNT/Graphics/Makefile.kmk	(revision 35380)
+++ trunk/src/VBox/Additions/WINNT/Graphics/Makefile.kmk	(revision 35381)
@@ -46,12 +46,12 @@
 	$(PATH_TARGET)/VBoxVideoCat.dir
 
-$(PATH_TARGET)/VBoxVideoCat.dir/VBoxVideo.inf: $(PATH_SUB_CURRENT)/Miniport/VBoxVideo.inf $(MAKEFILE_CURRENT) | $$(call DIRDEP,$$(@D))
+$(PATH_TARGET)/VBoxVideoCat.dir/VBoxVideo.inf: $(PATH_SUB_CURRENT)/Miniport/VBoxVideo.inf $(MAKEFILE_CURRENT) | $$(dir $$@)
 	$(call MSG_GENERATE,VBoxVideo-inf,$@,$<)
 	$(call VBOX_EDIT_INF_FN,$<,$@)
 
-$(PATH_TARGET)/VBoxVideoCat.dir/VBoxVideo.sys: $$(TARGET_VBoxVideo) | $$(call DIRDEP,$$(@D))
-	$(INSTALL) -m 644 $< $(@D)
-
-$(PATH_TARGET)/VBoxVideoCat.dir/VBoxDisp.dll: $$(TARGET_VBoxDisp) | $$(call DIRDEP,$$(@D))
+$(PATH_TARGET)/VBoxVideoCat.dir/VBoxVideo.sys: $$(TARGET_VBoxVideo) | $$(dir $$@)
+	$(INSTALL) -m 644 $< $(@D)
+
+$(PATH_TARGET)/VBoxVideoCat.dir/VBoxDisp.dll: $$(TARGET_VBoxDisp) | $$(dir $$@)
 	$(INSTALL) -m 644 $< $(@D)
 
@@ -122,17 +122,17 @@
 VBOXWDDM_EDIT_INF_GL_FN_ARG      = $(if $(VBOXWDDM_WITH_GL),-e 's/^;gl  *//', -e '/^;gl /d')
 
-$(PATH_TARGET)/VBoxVideoWddmCat.dir/VBoxVideoWddm.inf: $(PATH_SUB_CURRENT)/Miniport/wddm/VBoxVideoWddm.inf $(MAKEFILE_CURRENT) | $$(call DIRDEP,$$(@D))
+$(PATH_TARGET)/VBoxVideoWddmCat.dir/VBoxVideoWddm.inf: $(PATH_SUB_CURRENT)/Miniport/wddm/VBoxVideoWddm.inf $(MAKEFILE_CURRENT) | $$(dir $$@)
 	$(call MSG_GENERATE,VBoxVideoWddm-inf,$@,$<)
 	$(call VBOX_EDIT_INF_FN,$<,$@ $(VBOXWDDM_EDIT_INF_DISPD3D_FN_ARG) $(VBOXWDDM_EDIT_INF_GL_FN_ARG))
 
-$(PATH_TARGET)/VBoxVideoWddmCat.dir/VBoxVideoWddm.sys: $$(TARGET_VBoxVideoWddm) | $$(call DIRDEP,$$(@D))
+$(PATH_TARGET)/VBoxVideoWddmCat.dir/VBoxVideoWddm.sys: $$(TARGET_VBoxVideoWddm) | $$(dir $$@)
 	$(INSTALL) -m 644 $< $(@D)
 
 ifdef VBOXWDDM_WITH_DISPD3D
-$(PATH_TARGET)/VBoxVideoWddmCat.dir/VBoxDispD3D.dll: $$(TARGET_VBoxDispD3D) | $$(call DIRDEP,$$(@D))
+$(PATH_TARGET)/VBoxVideoWddmCat.dir/VBoxDispD3D.dll: $$(TARGET_VBoxDispD3D) | $$(dir $$@)
 	$(INSTALL) -m 644 $< $(@D)
 
  ifeq ($(KBUILD_TARGET_ARCH),amd64)
-$(PATH_TARGET)/VBoxVideoWddmCat.dir/VBoxDispD3D-x86.dll: $$(TARGET_VBoxDispD3D-x86) | $$(call DIRDEP,$$(@D))
+$(PATH_TARGET)/VBoxVideoWddmCat.dir/VBoxDispD3D-x86.dll: $$(TARGET_VBoxDispD3D-x86) | $$(dir $$@)
 	$(INSTALL) -m 644 $< $(@D)
  endif
@@ -140,57 +140,57 @@
 
 ifdef VBOXWDDM_WITH_GL
-$(PATH_TARGET)/VBoxVideoWddmCat.dir/VBoxOGL.dll: $$(TARGET_VBoxOGL) | $$(call DIRDEP,$$(@D))
-	$(INSTALL) -m 644 $< $(@D)
-
-$(PATH_TARGET)/VBoxVideoWddmCat.dir/VBoxD3D9wddm.dll: $$(TARGET_VBoxD3D9wddm) | $$(call DIRDEP,$$(@D))
-	$(INSTALL) -m 644 $< $(@D)
-
-$(PATH_TARGET)/VBoxVideoWddmCat.dir/wined3dwddm.dll: $$(TARGET_wined3dwddm) | $$(call DIRDEP,$$(@D))
-	$(INSTALL) -m 644 $< $(@D)
-
-$(PATH_TARGET)/VBoxVideoWddmCat.dir/VBoxOGLarrayspu.dll: $$(TARGET_VBoxOGLarrayspu) | $$(call DIRDEP,$$(@D))
-	$(INSTALL) -m 644 $< $(@D)
-
-$(PATH_TARGET)/VBoxVideoWddmCat.dir/VBoxOGLcrutil.dll: $$(TARGET_VBoxOGLcrutil) | $$(call DIRDEP,$$(@D))
-	$(INSTALL) -m 644 $< $(@D)
-
-$(PATH_TARGET)/VBoxVideoWddmCat.dir/VBoxOGLerrorspu.dll: $$(TARGET_VBoxOGLerrorspu) | $$(call DIRDEP,$$(@D))
-	$(INSTALL) -m 644 $< $(@D)
-
-$(PATH_TARGET)/VBoxVideoWddmCat.dir/VBoxOGLfeedbackspu.dll: $$(TARGET_VBoxOGLfeedbackspu) | $$(call DIRDEP,$$(@D))
-	$(INSTALL) -m 644 $< $(@D)
-
-$(PATH_TARGET)/VBoxVideoWddmCat.dir/VBoxOGLpackspu.dll: $$(TARGET_VBoxOGLpackspu) | $$(call DIRDEP,$$(@D))
-	$(INSTALL) -m 644 $< $(@D)
-
-$(PATH_TARGET)/VBoxVideoWddmCat.dir/VBoxOGLpassthroughspu.dll: $$(TARGET_VBoxOGLpassthroughspu) | $$(call DIRDEP,$$(@D))
+$(PATH_TARGET)/VBoxVideoWddmCat.dir/VBoxOGL.dll: $$(TARGET_VBoxOGL) | $$(dir $$@)
+	$(INSTALL) -m 644 $< $(@D)
+
+$(PATH_TARGET)/VBoxVideoWddmCat.dir/VBoxD3D9wddm.dll: $$(TARGET_VBoxD3D9wddm) | $$(dir $$@)
+	$(INSTALL) -m 644 $< $(@D)
+
+$(PATH_TARGET)/VBoxVideoWddmCat.dir/wined3dwddm.dll: $$(TARGET_wined3dwddm) | $$(dir $$@)
+	$(INSTALL) -m 644 $< $(@D)
+
+$(PATH_TARGET)/VBoxVideoWddmCat.dir/VBoxOGLarrayspu.dll: $$(TARGET_VBoxOGLarrayspu) | $$(dir $$@)
+	$(INSTALL) -m 644 $< $(@D)
+
+$(PATH_TARGET)/VBoxVideoWddmCat.dir/VBoxOGLcrutil.dll: $$(TARGET_VBoxOGLcrutil) | $$(dir $$@)
+	$(INSTALL) -m 644 $< $(@D)
+
+$(PATH_TARGET)/VBoxVideoWddmCat.dir/VBoxOGLerrorspu.dll: $$(TARGET_VBoxOGLerrorspu) | $$(dir $$@)
+	$(INSTALL) -m 644 $< $(@D)
+
+$(PATH_TARGET)/VBoxVideoWddmCat.dir/VBoxOGLfeedbackspu.dll: $$(TARGET_VBoxOGLfeedbackspu) | $$(dir $$@)
+	$(INSTALL) -m 644 $< $(@D)
+
+$(PATH_TARGET)/VBoxVideoWddmCat.dir/VBoxOGLpackspu.dll: $$(TARGET_VBoxOGLpackspu) | $$(dir $$@)
+	$(INSTALL) -m 644 $< $(@D)
+
+$(PATH_TARGET)/VBoxVideoWddmCat.dir/VBoxOGLpassthroughspu.dll: $$(TARGET_VBoxOGLpassthroughspu) | $$(dir $$@)
 	$(INSTALL) -m 644 $< $(@D)
 
  ifeq ($(KBUILD_TARGET_ARCH), amd64)
-$(PATH_TARGET)/VBoxVideoWddmCat.dir/VBoxOGL-x86.dll: $$(TARGET_VBoxOGL-x86) | $$(call DIRDEP,$$(@D))
-	$(INSTALL) -m 644 $< $(@D)
-
-$(PATH_TARGET)/VBoxVideoWddmCat.dir/VBoxD3D9wddm-x86.dll: $$(TARGET_VBoxD3D9wddm-x86) | $$(call DIRDEP,$$(@D))
-	$(INSTALL) -m 644 $< $(@D)
-
-$(PATH_TARGET)/VBoxVideoWddmCat.dir/wined3dwddm-x86.dll: $$(TARGET_wined3dwddm-x86) | $$(call DIRDEP,$$(@D))
-	$(INSTALL) -m 644 $< $(@D)
-
-$(PATH_TARGET)/VBoxVideoWddmCat.dir/VBoxOGLarrayspu-x86.dll: $$(TARGET_VBoxOGLarrayspu-x86) | $$(call DIRDEP,$$(@D))
-	$(INSTALL) -m 644 $< $(@D)
-
-$(PATH_TARGET)/VBoxVideoWddmCat.dir/VBoxOGLcrutil-x86.dll: $$(TARGET_VBoxOGLcrutil-x86) | $$(call DIRDEP,$$(@D))
-	$(INSTALL) -m 644 $< $(@D)
-
-$(PATH_TARGET)/VBoxVideoWddmCat.dir/VBoxOGLerrorspu-x86.dll: $$(TARGET_VBoxOGLerrorspu-x86) | $$(call DIRDEP,$$(@D))
-	$(INSTALL) -m 644 $< $(@D)
-
-$(PATH_TARGET)/VBoxVideoWddmCat.dir/VBoxOGLfeedbackspu-x86.dll: $$(TARGET_VBoxOGLfeedbackspu-x86) | $$(call DIRDEP,$$(@D))
-	$(INSTALL) -m 644 $< $(@D)
-
-$(PATH_TARGET)/VBoxVideoWddmCat.dir/VBoxOGLpackspu-x86.dll: $$(TARGET_VBoxOGLpackspu-x86) | $$(call DIRDEP,$$(@D))
-	$(INSTALL) -m 644 $< $(@D)
-
-$(PATH_TARGET)/VBoxVideoWddmCat.dir/VBoxOGLpassthroughspu-x86.dll: $$(TARGET_VBoxOGLpassthroughspu-x86) | $$(call DIRDEP,$$(@D))
+$(PATH_TARGET)/VBoxVideoWddmCat.dir/VBoxOGL-x86.dll: $$(TARGET_VBoxOGL-x86) | $$(dir $$@)
+	$(INSTALL) -m 644 $< $(@D)
+
+$(PATH_TARGET)/VBoxVideoWddmCat.dir/VBoxD3D9wddm-x86.dll: $$(TARGET_VBoxD3D9wddm-x86) | $$(dir $$@)
+	$(INSTALL) -m 644 $< $(@D)
+
+$(PATH_TARGET)/VBoxVideoWddmCat.dir/wined3dwddm-x86.dll: $$(TARGET_wined3dwddm-x86) | $$(dir $$@)
+	$(INSTALL) -m 644 $< $(@D)
+
+$(PATH_TARGET)/VBoxVideoWddmCat.dir/VBoxOGLarrayspu-x86.dll: $$(TARGET_VBoxOGLarrayspu-x86) | $$(dir $$@)
+	$(INSTALL) -m 644 $< $(@D)
+
+$(PATH_TARGET)/VBoxVideoWddmCat.dir/VBoxOGLcrutil-x86.dll: $$(TARGET_VBoxOGLcrutil-x86) | $$(dir $$@)
+	$(INSTALL) -m 644 $< $(@D)
+
+$(PATH_TARGET)/VBoxVideoWddmCat.dir/VBoxOGLerrorspu-x86.dll: $$(TARGET_VBoxOGLerrorspu-x86) | $$(dir $$@)
+	$(INSTALL) -m 644 $< $(@D)
+
+$(PATH_TARGET)/VBoxVideoWddmCat.dir/VBoxOGLfeedbackspu-x86.dll: $$(TARGET_VBoxOGLfeedbackspu-x86) | $$(dir $$@)
+	$(INSTALL) -m 644 $< $(@D)
+
+$(PATH_TARGET)/VBoxVideoWddmCat.dir/VBoxOGLpackspu-x86.dll: $$(TARGET_VBoxOGLpackspu-x86) | $$(dir $$@)
+	$(INSTALL) -m 644 $< $(@D)
+
+$(PATH_TARGET)/VBoxVideoWddmCat.dir/VBoxOGLpassthroughspu-x86.dll: $$(TARGET_VBoxOGLpassthroughspu-x86) | $$(dir $$@)
 	$(INSTALL) -m 644 $< $(@D)
  endif
Index: trunk/src/VBox/Additions/WINNT/MouseFilter/Makefile.kmk
===================================================================
--- trunk/src/VBox/Additions/WINNT/MouseFilter/Makefile.kmk	(revision 35380)
+++ trunk/src/VBox/Additions/WINNT/MouseFilter/Makefile.kmk	(revision 35381)
@@ -53,5 +53,5 @@
 VBoxMouse-inf_BLDDIRS = $(PATH_TARGET)/VBoxMouseCat.dir
 
-$(PATH_TARGET)/VBoxMouseCat.dir/VBoxMouse.inf: $(PATH_SUB_CURRENT)/VBoxMouse.inf $(MAKEFILE_CURRENT) | $$(call DIRDEP,$$(@D))
+$(PATH_TARGET)/VBoxMouseCat.dir/VBoxMouse.inf: $(PATH_SUB_CURRENT)/VBoxMouse.inf $(MAKEFILE_CURRENT) | $$(dir $$@)
 	$(call MSG_GENERATE,VBoxMouse-inf,$@,$<)
 	$(call VBOX_EDIT_INF_FN,$<,$@)
Index: trunk/src/VBox/Devices/PC/Etherboot-src/Makefile.kmk
===================================================================
--- trunk/src/VBox/Devices/PC/Etherboot-src/Makefile.kmk	(revision 35380)
+++ trunk/src/VBox/Devices/PC/Etherboot-src/Makefile.kmk	(revision 35381)
@@ -153,5 +153,5 @@
 
 # Rebuild everything whenever the Makefile etc. is changed. Must be LAST in the dependency list!
-MAKEDEPS=       $(PATH_SUB_CURRENT)/Makefile.kmk $(PATH_SUB_CURRENT)/Config $(PATH_SUB_CURRENT)/arch/$(ARCH)/Config | $(call DIRDEP,$(PATH_TARGET))
+MAKEDEPS=       $(PATH_SUB_CURRENT)/Makefile.kmk $(PATH_SUB_CURRENT)/Config $(PATH_SUB_CURRENT)/arch/$(ARCH)/Config | $(PATH_TARGET)/
 
 # The core (card-independent part) of Etherboot.
Index: trunk/src/VBox/Disassembler/testcase/Makefile.kmk
===================================================================
--- trunk/src/VBox/Disassembler/testcase/Makefile.kmk	(revision 35380)
+++ trunk/src/VBox/Disassembler/testcase/Makefile.kmk	(revision 35381)
@@ -77,13 +77,13 @@
 	$(VBOX_DISAS_TESTS_BIN:.asm=-64.bin))
 
-$(addprefix $(VBOX_DISAS_TEST_OUT_DIR)/, $(VBOX_DISAS_TESTS_BIN:.asm=-16.bin)): $(PATH_SUB_CURRENT)/$$(patsubst %-16.bin,%.asm,$$(notdir $$(@))) | $$(call DIRDEP,$$(@D))
+$(addprefix $(VBOX_DISAS_TEST_OUT_DIR)/, $(VBOX_DISAS_TESTS_BIN:.asm=-16.bin)): $(PATH_SUB_CURRENT)/$$(patsubst %-16.bin,%.asm,$$(notdir $$(@))) | $$(dir $$@)
 	@$(ECHO) "Assembling: $(<F) into $(@F)"
 	$(TOOL_YASM_AS) -f bin -a x86 --force-strict -DTEST_BITS=16 -o $@ $<
 
-$(addprefix $(VBOX_DISAS_TEST_OUT_DIR)/, $(VBOX_DISAS_TESTS_BIN:.asm=-32.bin)): $(PATH_SUB_CURRENT)/$$(patsubst %-32.bin,%.asm,$$(notdir $$(@))) | $$(call DIRDEP,$$(@D))
+$(addprefix $(VBOX_DISAS_TEST_OUT_DIR)/, $(VBOX_DISAS_TESTS_BIN:.asm=-32.bin)): $(PATH_SUB_CURRENT)/$$(patsubst %-32.bin,%.asm,$$(notdir $$(@))) | $$(dir $$@)
 	@$(ECHO) "Assembling: $(<F) into $(@F)"
 	$(TOOL_YASM_AS) -f bin -a x86 --force-strict -DTEST_BITS=32 -o $@ $<
 
-$(addprefix $(VBOX_DISAS_TEST_OUT_DIR)/, $(VBOX_DISAS_TESTS_BIN:.asm=-64.bin)): $(PATH_SUB_CURRENT)/$$(patsubst %-64.bin,%.asm,$$(notdir $$(@))) | $$(call DIRDEP,$$(@D))
+$(addprefix $(VBOX_DISAS_TEST_OUT_DIR)/, $(VBOX_DISAS_TESTS_BIN:.asm=-64.bin)): $(PATH_SUB_CURRENT)/$$(patsubst %-64.bin,%.asm,$$(notdir $$(@))) | $$(dir $$@)
 	@$(ECHO) "Assembling: $(<F) into $(@F)"
 	$(TOOL_YASM_AS) -f bin -a x86 --force-strict -DTEST_BITS=64 -o $@ $<
@@ -96,13 +96,13 @@
 	$(VBOX_DISAS_TESTS_BUILD:.asm=-64-disas.asm))
 
-$(addprefix $(VBOX_DISAS_TEST_OUT_DIR)/, $(VBOX_DISAS_TESTS_BUILD:.asm=-16-disas.asm)): $$(subst -disas.asm,.bin,$$@) $$(INSTARGET_tstDisasm-2) | $$(call DIRDEP,$$(@D))
+$(addprefix $(VBOX_DISAS_TEST_OUT_DIR)/, $(VBOX_DISAS_TESTS_BUILD:.asm=-16-disas.asm)): $$(subst -disas.asm,.bin,$$@) $$(INSTARGET_tstDisasm-2) | $$(dir $$@)
 	@$(ECHO) "Generating: $(@F) from $(<F)"
 	$(REDIRECT) -E VBOX_LOG_DEST=nofile -o $@ -- $(INSTARGET_tstDisasm-2) --style=yasm --cpumode=16 $<
 
-$(addprefix $(VBOX_DISAS_TEST_OUT_DIR)/, $(VBOX_DISAS_TESTS_BUILD:.asm=-32-disas.asm)): $$(subst -disas.asm,.bin,$$@) $$(INSTARGET_tstDisasm-2) | $$(call DIRDEP,$$(@D))
+$(addprefix $(VBOX_DISAS_TEST_OUT_DIR)/, $(VBOX_DISAS_TESTS_BUILD:.asm=-32-disas.asm)): $$(subst -disas.asm,.bin,$$@) $$(INSTARGET_tstDisasm-2) | $$(dir $$@)
 	@$(ECHO) "Generating: $(@F) from $(<F)"
 	$(REDIRECT) -E VBOX_LOG_DEST=nofile -o $@ -- $(INSTARGET_tstDisasm-2) --style=yasm --cpumode=32 $<
 
-$(addprefix $(VBOX_DISAS_TEST_OUT_DIR)/, $(VBOX_DISAS_TESTS_BUILD:.asm=-64-disas.asm)): $$(subst -disas.asm,.bin,$$@) $$(INSTARGET_tstDisasm-2) | $$(call DIRDEP,$$(@D))
+$(addprefix $(VBOX_DISAS_TEST_OUT_DIR)/, $(VBOX_DISAS_TESTS_BUILD:.asm=-64-disas.asm)): $$(subst -disas.asm,.bin,$$@) $$(INSTARGET_tstDisasm-2) | $$(dir $$@)
 	@$(ECHO) "Generating: $(@F) from $(<F)"
 	$(REDIRECT) -E VBOX_LOG_DEST=nofile -o $@ -- $(INSTARGET_tstDisasm-2) --style=yasm --cpumode=64 $<
@@ -114,13 +114,13 @@
 	$(VBOX_DISAS_TESTS_BUILD:.asm=-64-disas.bin))
 
-$(addprefix $(VBOX_DISAS_TEST_OUT_DIR)/, $(VBOX_DISAS_TESTS_BUILD:.asm=-16-disas.bin)): $$(subst .bin,.asm,$$@) | $$(call DIRDEP,$$(@D))
+$(addprefix $(VBOX_DISAS_TEST_OUT_DIR)/, $(VBOX_DISAS_TESTS_BUILD:.asm=-16-disas.bin)): $$(subst .bin,.asm,$$@) | $$(dir $$@)
 	@$(ECHO) "Re-assembling: $(<F) into $(@F)"
 	$(TOOL_YASM_AS) -f bin -a x86 --force-strict -DTEST_BITS=16 -o $@ $<
 
-$(addprefix $(VBOX_DISAS_TEST_OUT_DIR)/, $(VBOX_DISAS_TESTS_BUILD:.asm=-32-disas.bin)): $$(subst .bin,.asm,$$@) | $$(call DIRDEP,$$(@D))
+$(addprefix $(VBOX_DISAS_TEST_OUT_DIR)/, $(VBOX_DISAS_TESTS_BUILD:.asm=-32-disas.bin)): $$(subst .bin,.asm,$$@) | $$(dir $$@)
 	@$(ECHO) "Re-assembling: $(<F) into $(@F)"
 	$(TOOL_YASM_AS) -f bin -a x86 --force-strict -DTEST_BITS=32 -o $@ $<
 
-$(addprefix $(VBOX_DISAS_TEST_OUT_DIR)/, $(VBOX_DISAS_TESTS_BUILD:.asm=-64-disas.bin)): $$(subst .bin,.asm,$$@) | $$(call DIRDEP,$$(@D))
+$(addprefix $(VBOX_DISAS_TEST_OUT_DIR)/, $(VBOX_DISAS_TESTS_BUILD:.asm=-64-disas.bin)): $$(subst .bin,.asm,$$@) | $$(dir $$@)
 	@$(ECHO) "Re-assembling: $(<F) into $(@F)"
 	$(TOOL_YASM_AS) -f bin -a x86 --force-strict -DTEST_BITS=64 -o $@ $<
@@ -131,5 +131,5 @@
 $(VBOX_DISAS_TESTS_BUILD:.asm=-16.tst)\
 $(VBOX_DISAS_TESTS_BUILD:.asm=-32.tst)\
-$(VBOX_DISAS_TESTS_BUILD:.asm=-64.tst) ): $$(subst .tst,-disas.bin,$$@) | $$(call DIRDEP,$$(@D))
+$(VBOX_DISAS_TESTS_BUILD:.asm=-64.tst) ): $$(subst .tst,-disas.bin,$$@) | $$(dir $$@)
 	@$(ECHO) "Verifying build: $(<F) and $(@F:.tst=.bin)"
 	@$(RM) -f $@
@@ -143,5 +143,5 @@
 VBOX_DISAS_TESTS += $(foreach test, $(VBOX_DISAS_TESTS_INVALID:.asm=), $(test)-16.tst $(test)-32.tst $(test)-64.tst)
 
-$(addprefix $(VBOX_DISAS_TEST_OUT_DIR)/, $(VBOX_DISAS_TESTS_INVALID:.asm=-16.tst)): $$(patsubst %.tst,%.bin,$$@) $$(INSTARGET_tstDisasm-2) | $$(call DIRDEP,$$(@D))
+$(addprefix $(VBOX_DISAS_TEST_OUT_DIR)/, $(VBOX_DISAS_TESTS_INVALID:.asm=-16.tst)): $$(patsubst %.tst,%.bin,$$@) $$(INSTARGET_tstDisasm-2) | $$(dir $$@)
 	@$(ECHO) "TESTING: $(@F) [--undef-op=all]"
 	@$(RM) -f $@
@@ -150,5 +150,5 @@
 	@$(ECHO) " PASSED:  $(@F) [--undef-op=all]"
 
-$(addprefix $(VBOX_DISAS_TEST_OUT_DIR)/, $(VBOX_DISAS_TESTS_INVALID:.asm=-32.tst)): $$(patsubst %.tst,%.bin,$$@) $$(INSTARGET_tstDisasm-2) | $$(call DIRDEP,$$(@D))
+$(addprefix $(VBOX_DISAS_TEST_OUT_DIR)/, $(VBOX_DISAS_TESTS_INVALID:.asm=-32.tst)): $$(patsubst %.tst,%.bin,$$@) $$(INSTARGET_tstDisasm-2) | $$(dir $$@)
 	@$(ECHO) "TESTING: $(@F) [--undef-op=all]"
 	@$(RM) -f $@
@@ -157,5 +157,5 @@
 	@$(ECHO) " PASSED:  $(@F) [--undef-op=all]"
 
-$(addprefix $(VBOX_DISAS_TEST_OUT_DIR)/, $(VBOX_DISAS_TESTS_INVALID:.asm=-64.tst)): $$(patsubst %.tst,%.bin,$$@) $$(INSTARGET_tstDisasm-2) | $$(call DIRDEP,$$(@D))
+$(addprefix $(VBOX_DISAS_TEST_OUT_DIR)/, $(VBOX_DISAS_TESTS_INVALID:.asm=-64.tst)): $$(patsubst %.tst,%.bin,$$@) $$(INSTARGET_tstDisasm-2) | $$(dir $$@)
 	@$(ECHO) "TESTING: $(@F) [--undef-op=all]"
 	@$(RM) -f $@
Index: trunk/src/VBox/HostDrivers/Support/Makefile.kmk
===================================================================
--- trunk/src/VBox/HostDrivers/Support/Makefile.kmk	(revision 35380)
+++ trunk/src/VBox/HostDrivers/Support/Makefile.kmk	(revision 35381)
@@ -211,5 +211,5 @@
 VBoxDrv-inf_BLDDIRS = $(PATH_TARGET)/VBoxDrvCat.dir
 
-$(PATH_TARGET)/VBoxDrvCat.dir/VBoxDrv.inf: $(PATH_SUB_CURRENT)/win/VBoxDrv.inf $(MAKEFILE_CURRENT) | $$(call DIRDEP,$$(@D))
+$(PATH_TARGET)/VBoxDrvCat.dir/VBoxDrv.inf: $(PATH_SUB_CURRENT)/win/VBoxDrv.inf $(MAKEFILE_CURRENT) | $$(dir $$@)
 	$(call MSG_GENERATE,VBoxDrv-inf,$@,$<)
 	$(call VBOX_EDIT_INF_FN,$<,$@)
@@ -220,5 +220,5 @@
 	$(PATH_TARGET)/VBoxDrvCat.dir/VBoxDrv.cat
 
-$(PATH_TARGET)/VBoxDrvCat.dir/VBoxDrv.sys: $$(TARGET_VBoxDrv) | $$(call DIRDEP,$$(@D))
+$(PATH_TARGET)/VBoxDrvCat.dir/VBoxDrv.sys: $$(TARGET_VBoxDrv) | $$(dir $$@)
 	$(INSTALL) -m 644 $< $(@D)
 
Index: trunk/src/VBox/HostDrivers/VBoxUSB/win/Makefile.kmk
===================================================================
--- trunk/src/VBox/HostDrivers/VBoxUSB/win/Makefile.kmk	(revision 35380)
+++ trunk/src/VBox/HostDrivers/VBoxUSB/win/Makefile.kmk	(revision 35381)
@@ -157,13 +157,13 @@
 	$(PATH_TARGET)/VBoxUSBMonCat.dir
 
-$(PATH_TARGET)/VBoxUSBCat.dir/VBoxUSB.inf: $(PATH_SUB_CURRENT)/Device/VBoxUSB.inf $(MAKEFILE_CURRENT) | $$(call DIRDEP,$$(@D))
+$(PATH_TARGET)/VBoxUSBCat.dir/VBoxUSB.inf: $(PATH_SUB_CURRENT)/Device/VBoxUSB.inf $(MAKEFILE_CURRENT) | $$(dir $$@)
 	$(call MSG_GENERATE,install-infs,$@,$<)
 	$(call VBOX_EDIT_INF_FN,$<,$@)
 
-$(PATH_TARGET)/VBoxUSBMonCat.dir/VBoxUSBMon.inf: $(PATH_SUB_CURRENT)/Monitor/VBoxUSBMon.inf $(MAKEFILE_CURRENT) | $$(call DIRDEP,$$(@D))
+$(PATH_TARGET)/VBoxUSBMonCat.dir/VBoxUSBMon.inf: $(PATH_SUB_CURRENT)/Monitor/VBoxUSBMon.inf $(MAKEFILE_CURRENT) | $$(dir $$@)
 	$(call MSG_GENERATE,install-infs,$@,$<)
 	$(call VBOX_EDIT_INF_FN,$<,$@)
 
-$(PATH_TARGET)/VBoxUSBFltCat.dir/VBoxUSBFlt.inf: $(PATH_SUB_CURRENT)/Filter/VBoxUSBFlt.inf $(MAKEFILE_CURRENT) | $$(call DIRDEP,$$(@D))
+$(PATH_TARGET)/VBoxUSBFltCat.dir/VBoxUSBFlt.inf: $(PATH_SUB_CURRENT)/Filter/VBoxUSBFlt.inf $(MAKEFILE_CURRENT) | $$(dir $$@)
 	$(call MSG_GENERATE,install-infs,$@,$<)
 	$(call VBOX_EDIT_INF_FN,$<,$@)
@@ -176,5 +176,5 @@
 	$(PATH_TARGET)/VBoxUSBMonCat.dir/VBoxUSBMon.sys
 
-$(PATH_TARGET)/VBoxUSBCat.dir/VBoxUSB.sys: $$(TARGET_VBoxUSB) | $$(call DIRDEP,$$(@D))
+$(PATH_TARGET)/VBoxUSBCat.dir/VBoxUSB.sys: $$(TARGET_VBoxUSB) | $$(dir $$@)
 	$(INSTALL) -m 644 $< $(@D)
 
@@ -185,5 +185,5 @@
 	$(call VBOX_MAKE_CAT_FN, $(@D),$@)
 
-$(PATH_TARGET)/VBoxUSBMonCat.dir/VBoxUSBMon.sys: $$(TARGET_VBoxUSBMon) | $$(call DIRDEP,$$(@D))
+$(PATH_TARGET)/VBoxUSBMonCat.dir/VBoxUSBMon.sys: $$(TARGET_VBoxUSBMon) | $$(dir $$@)
 	$(INSTALL) -m 644 $< $(@D)
 
Index: trunk/src/VBox/Main/Makefile.kmk
===================================================================
--- trunk/src/VBox/Main/Makefile.kmk	(revision 35380)
+++ trunk/src/VBox/Main/Makefile.kmk	(revision 35381)
@@ -831,5 +831,5 @@
 + $(VBOX_PATH_SDK)/bindings/mscom/include/VirtualBox.h \
 + $(VBoxCOM_0_OUTDIR)/VirtualBox.tlb \
-+ $(VBOX_PATH_SDK)/bindings/mscom/lib/VirtualBox.tlb: $(VBOX_IDL_FILE.MSCOM) | $(call DIRDEP,$(VBoxCOM_0_OUTDIR))
++ $(VBOX_PATH_SDK)/bindings/mscom/lib/VirtualBox.tlb: $(VBOX_IDL_FILE.MSCOM) | $$(dir $$@)
 	$(VBOX_MAIN_IDL) $(IDL_DEFS) \
 		/out $(call VBOX_FN_MAKE_WIN_PATH,$(VBoxCOM_0_OUTDIR)) \